=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2009-06-29 20:32:49 +0000
+++ drizzled/item/sum.cc	2009-07-08 04:26:02 +0000
@@ -260,11 +260,13 @@
           in_sum_func->outer_fields.push_back(field);
         }
         else
-          sel->full_group_by_flag|= NON_AGG_FIELD_USED;
+        {
+          sel->full_group_by_flag.set(NON_AGG_FIELD_USED);
+        }
       }
       if (sel->nest_level > aggr_level &&
-          (sel->full_group_by_flag & SUM_FUNC_USED) &&
-          !sel->group_list.elements)
+          (sel->full_group_by_flag.test(SUM_FUNC_USED)) &&
+          ! sel->group_list.elements)
       {
         my_message(ER_MIX_OF_GROUP_FUNC_AND_FIELDS,
                    ER(ER_MIX_OF_GROUP_FUNC_AND_FIELDS), MYF(0));
@@ -272,7 +274,7 @@
       }
     }
   }
-  aggr_sel->full_group_by_flag|= SUM_FUNC_USED;
+  aggr_sel->full_group_by_flag.set(SUM_FUNC_USED);
   update_used_tables();
   session->lex->in_sum_func= in_sum_func;
   return false;

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2009-07-08 03:52:20 +0000
+++ drizzled/join.cc	2009-07-08 04:26:02 +0000
@@ -365,7 +365,9 @@
 
     MODE_ONLY_FULL_GROUP_BY is enabled here by default
   */
-  if (!group_list && select_lex->full_group_by_flag == (NON_AGG_FIELD_USED | SUM_FUNC_USED))
+  if (! group_list && 
+      select_lex->full_group_by_flag.test(NON_AGG_FIELD_USED) &&
+      select_lex->full_group_by_flag.test(SUM_FUNC_USED))
   {
     my_message(ER_MIX_OF_GROUP_FUNC_AND_FIELDS,
                ER(ER_MIX_OF_GROUP_FUNC_AND_FIELDS), MYF(0));

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2009-06-13 21:21:13 +0000
+++ drizzled/sql_base.h	2009-07-08 04:26:02 +0000
@@ -72,8 +72,11 @@
   A set of constants used for checking non aggregated fields and sum
   functions mixture in the ONLY_FULL_GROUP_BY_MODE.
 */
-#define NON_AGG_FIELD_USED  1
-#define SUM_FUNC_USED       2
+enum enum_group_by_mode_type
+{
+  NON_AGG_FIELD_USED= 0,
+  SUM_FUNC_USED
+};
 
 /**
   This enumeration type is used only by the function find_item_in_list

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2009-06-08 18:19:53 +0000
+++ drizzled/sql_lex.cc	2009-07-08 04:26:02 +0000
@@ -1417,7 +1417,7 @@
   non_agg_fields.empty();
   cond_value= having_value= Item::COND_UNDEF;
   inner_refs_list.empty();
-  full_group_by_flag= 0;
+  full_group_by_flag.reset();
 }
 
 /*

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2009-06-18 08:42:07 +0000
+++ drizzled/sql_lex.h	2009-07-08 04:26:02 +0000
@@ -39,6 +39,8 @@
 #include "drizzled/item/param.h"
 #include "drizzled/index_hint.h"
 
+#include <bitset>
+
 class select_result_interceptor;
 
 /* YACC and LEX Definitions */
@@ -509,7 +511,7 @@
       1 - aggregate functions are used in this select,
           defined as SUM_FUNC_USED.
   */
-  uint8_t full_group_by_flag;
+  std::bitset<2> full_group_by_flag;
   void init_query();
   void init_select();
   Select_Lex_Unit* master_unit();

